#include <Rmath.h>
#include <R.h>

double nr_main(double beta_tilda, double beta_hat, double b_dis, double lam1, double c, double tol)
{
     double f;
	 double b_old;
	 double f_old;
	 f = beta_tilda*(1+lam1*b_dis*b_dis/sqrt(b_dis*b_dis*beta_tilda*beta_tilda+c))-beta_hat;
	 while(fabs(f)>tol)
	 {
	     b_old = beta_tilda;
		 f_old = f;
		 beta_tilda = beta_tilda-f/(1+lam1*b_dis*b_dis*c/(pow(b_dis*b_dis*beta_tilda*beta_tilda+c,3/2)));
		 f = beta_tilda*(1+lam1*b_dis*b_dis/sqrt(b_dis*b_dis*beta_tilda*beta_tilda+c))-beta_hat;
		 while(f/f_old <= -1)
		 {
		    beta_tilda = (beta_tilda+b_old)/2;
			f = beta_tilda*(1+lam1*b_dis*b_dis/sqrt(b_dis*b_dis*beta_tilda*beta_tilda+c))-beta_hat;
		 }
	 }
	 return beta_tilda;
}

double s_th_int(double beta_hat_jk, double lam, double b_jk, double *x_jk,int N)
{
     double out;
	 double tmp=0;
	 for (int i=0; i < N; i++){
	 tmp=tmp+x_jk[i]*x_jk[i];
	 }
	 tmp = sqrt(tmp);
	 if ((fabs(beta_hat_jk)-lam*b_jk/tmp)>0)
	 out = sign(beta_hat_jk)*(fabs(beta_hat_jk)-lam*b_jk/tmp);
	 else out = 0;
     return out;
}

double nr_intx(double beta_tilda_jk,double beta_hat_jk, double lam1, double lam2, double c1, double c2,double b_jk, int N, double *x_jk, double tol)
{ 
     double SSX=0;
	 double f;
	 double f_old;
	 double b_old;
	 for (int i=0; i<N; i++)
	 {
	 SSX = SSX+x_jk[i]*x_jk[i];
	 }
	 
	 if ((c1 > 0) && (c2 > 0))
	 {
	   if(fabs(beta_hat_jk)<=(lam2*b_jk/sqrt(SSX))) {
	   beta_tilda_jk = 0;
	   } 
	   else {
     f = -s_th_int(beta_hat_jk, lam2, b_jk, x_jk,N)+beta_tilda_jk*(1+lam1*b_jk*b_jk*(1/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1)+1/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2)));
     while(fabs(f)>tol){
     b_old = beta_tilda_jk;
     f_old = f;
     beta_tilda_jk = beta_tilda_jk-f/(1+lam1*b_jk*b_jk*c1/pow((b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1),(3/2))+lam1*b_jk*b_jk*c2/pow((b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2),(3/2)));
     f = -s_th_int(beta_hat_jk, lam2, b_jk, x_jk,N)+beta_tilda_jk*(1+lam1*b_jk*b_jk*(1/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1)+1/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2)));
     while((f/f_old) <= -1){
     beta_tilda_jk = (beta_tilda_jk+b_old)/2;
     f = -s_th_int(beta_hat_jk, lam2, b_jk, x_jk,N)+beta_tilda_jk*(1+lam1*b_jk*b_jk*(1/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1)+1/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2)));
     }     
     }
     }
	 }
	 else 
	 {
	  if(fabs(beta_hat_jk)<=((lam2+lam1)*b_jk/sqrt(SSX))) {
	  beta_tilda_jk = 0;
	  } 
	  else{
      if((c1==0) && (c2>0)){
      f = -s_th_int(beta_hat_jk, lam1+lam2, b_jk, x_jk, N)+beta_tilda_jk*(1+lam1*b_jk*b_jk/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2));
         while(fabs(f)>tol){
         b_old = beta_tilda_jk;
         f_old = f;
         beta_tilda_jk = beta_tilda_jk-f/(1+lam1*b_jk*b_jk*c2/pow((b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2),(3/2)));
         f = -s_th_int(beta_hat_jk, lam1+lam2, b_jk, x_jk, N)+beta_tilda_jk*(1+lam1*b_jk*b_jk/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2));
         while(f/f_old <= -1){
         beta_tilda_jk = (beta_tilda_jk+b_old)/2;
         f = -s_th_int(beta_hat_jk, lam1+lam2, b_jk, x_jk, N)+beta_tilda_jk*(1+lam1*b_jk*b_jk/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c2));
         }         
         }
      }
      if((c1>0) && (c2==0)){
      f = -s_th_int(beta_hat_jk, lam1+lam2, b_jk, x_jk, N)+beta_tilda_jk*(1+lam1*b_jk*b_jk/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1));
         while(fabs(f)>tol){
         b_old = beta_tilda_jk;
         f_old = f;
         beta_tilda_jk = beta_tilda_jk-f/(1+lam1*b_jk*b_jk*c1/pow((b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1),(3/2)));
         f = -s_th_int(beta_hat_jk, lam1+lam2, b_jk, x_jk, N)+beta_tilda_jk*(1+lam1*b_jk*b_jk/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1));
         while(f/f_old <= -1){
         beta_tilda_jk = (beta_tilda_jk+b_old)/2;
         f = -s_th_int(beta_hat_jk, lam1+lam2, b_jk, x_jk, N)+beta_tilda_jk*(1+lam1*b_jk*b_jk/sqrt(b_jk*b_jk*SSX*beta_tilda_jk*beta_tilda_jk+c1));
         }
         }
      }
      }
	}
	 return beta_tilda_jk;
}

void cd_update_testspeed(double *X, double *Y, int *N_subj, double *lambda1, double *lambda2, int *p_main, int *p_intx, int *Bspa1, int *Bspa2, double *Bspa3, double *beta_m, double *beta_int, double *epsi_cd, double *epsi_nr)
{
     int N = N_subj[0];
	 double lam1 = lambda1[0];
	 double lam2 = lambda2[0];
	 int p_m = p_main[0];
	 int p_int = p_intx[0];
	 double tol_cd = epsi_cd[0];
	 double tol_nr = epsi_nr[0];
	
     double delta = 1;
     double beta_m_old[p_m];
	 double beta_int_old[p_int];
	 double diff_m[p_m];
     double diff_int[p_int];
	 
 while(delta > tol_cd ){
      
      for (int i=0; i < p_m; i++){
	  beta_m_old[i] = beta_m[i];
	  }
	  for (int i=0; i < p_int; i++){
	  beta_int_old[i] = beta_int[i];
	  }

	 double b_jj = 1;      /* the diagnal of B matrix is always 1, unit weight for all SNPs */	  
	 double b_kk = 1; 
       /* update main effects */   
	 
     double tmp_int[N];	 
	 for (int k=0; k < N; k++){
       tmp_int[k] = 0;	 
	   for (int i=0; i < p_int; i++){
	  tmp_int[k] = tmp_int[k] + X[N*Bspa1[i]+k]*X[N*Bspa2[i]+k]*beta_int[i];
	  }
	 }
    for (int j=0; j < p_m; j++){
	
       /* calculate beta_hat; subtract tmp1 from Y is Y.tilda */

	 double beta_hat = 0;
	  for (int k=0; k < N; k++){
	 double tmp1 = 0;
	  for (int i=0; i < p_m; i++){
	  if(i != j){
	  tmp1 = tmp1 + X[N*i+k]*beta_m[i];
	  }
	  }
	  beta_hat = beta_hat + X[N*j+k]*(Y[k]-tmp1-tmp_int[k]);
	  }
	      
	    /* calculate c */ 
	  double c = 0;
	  for (int i=0; i < p_int; i++){
	  
	  if (Bspa2[i] == j){
 	  double tmp2 = 0;
      for (int k=0; k < N; k++){
	  tmp2 = tmp2 + X[N*Bspa1[i]+k]*X[N*j+k]*X[N*Bspa1[i]+k]*X[N*j+k];
	  }
	  c = c + Bspa3[i]*Bspa3[i]*beta_int[i]*beta_int[i]*tmp2;
	  }
	  
	  if (Bspa1[i] == j){
	  double tmp2 = 0;
	  for (int k=0; k < N; k++){
	  tmp2 = tmp2 + X[N*Bspa2[i]+k]*X[N*j+k]*X[N*Bspa2[i]+k]*X[N*j+k];
	  }
	  c = c + Bspa3[i]*Bspa3[i]*beta_int[i]*beta_int[i]*tmp2;
	  }
	  }	
	  
     if (c == 0){ 
	    if (fabs(beta_hat)-lam1*b_jj > 0){
	    beta_m[j] = sign(beta_hat)*(fabs(beta_hat)-lam1*b_jj);}
		else beta_m[j] = 0;
	 }

     if (c > 0){ 
	 beta_m[j] = nr_main(beta_m[j],beta_hat,b_jj,lam1,c,tol_nr);
	 }
     diff_m[j] = fabs(beta_m[j]-beta_m_old[j]);
	 }
     
     /* update interactions  */
	 
	 double tmp_m[N];
	 
	 for (int k=0; k < N; k++){
	  tmp_m[k] = 0;
	  for (int i=0; i < p_m; i++){
	    tmp_m[k] = tmp_m[k] + X[N*i+k]*beta_m[i];
	  }
	 }
	 
    for (int m=0; m < p_int; m++){
	
	  /* calculate beta_hat; subtract tmp1 from Y is Y.tilda */

	 double beta_hat = 0;
     double denom = 0;
	  for (int k=0; k < N; k++){
	  double tmp1 = 0;
	  for (int i=0; i < p_int; i++){
	  if(i!=m){
	  tmp1 = tmp1 + X[N*Bspa1[i]+k]*X[N*Bspa2[i]+k]*beta_int[i];
	  }
	  }
	  beta_hat = beta_hat + X[N*Bspa1[m]+k]*X[N*Bspa2[m]+k]*(Y[k]-tmp1-tmp_m[k]);
	  denom = denom + X[N*Bspa1[m]+k]*X[N*Bspa2[m]+k]*X[N*Bspa1[m]+k]*X[N*Bspa2[m]+k];
	  }
      beta_hat = beta_hat/denom;

      /* calculate c1 and c2 */
	 
      double c1 , c2;
	  c1 = b_jj*b_jj*beta_m[Bspa1[m]]*beta_m[Bspa1[m]];
	  c2 = b_kk*b_kk*beta_m[Bspa2[m]]*beta_m[Bspa2[m]];
	  
	  for (int i=0; i<p_int; i++){
	  
	  if( i != m){
	  if( Bspa2[i] == Bspa1[m]){
	  double tmp2 =0 ;
	  for(int k=0; k < N; k++){
	  tmp2 = tmp2 + X[N*Bspa1[i]+k]*X[N*Bspa1[m]+k]*X[N*Bspa1[i]+k]*X[N*Bspa1[m]+k];
	  }
	  c1 = c1 + Bspa3[i]*Bspa3[i]*beta_int[i]*beta_int[i]*tmp2;
	  }
	  
	  if(Bspa1[i] == Bspa1[m]){
	  double tmp2 =0;
	  for(int k=0; k < N; k++){
	  tmp2 = tmp2 + X[N*Bspa2[i]+k]*X[N*Bspa1[m]+k]*X[N*Bspa2[i]+k]*X[N*Bspa1[m]+k];
	  }
	  c1 = c1 + Bspa3[i]*Bspa3[i]*beta_int[i]*beta_int[i]*tmp2;
	  }
	  
	  if(Bspa2[i] == Bspa2[m]){
	  double tmp2 = 0;
	  for(int k=0; k < N; k++){
	  tmp2 = tmp2 + X[N*Bspa1[i]+k]*X[N*Bspa2[m]+k]*X[N*Bspa1[i]+k]*X[N*Bspa2[m]+k];
	  }
	  c2 = c2 + Bspa3[i]*Bspa3[i]*beta_int[i]*beta_int[i]*tmp2;
	  }
	  
	  if(Bspa1[i] == Bspa2[m]){
	  double tmp2 =0;
	  for(int k=0; k < N; k++){
	  tmp2 = tmp2 + X[N*Bspa2[i]+k]*X[N*Bspa2[m]+k]*X[N*Bspa2[i]+k]*X[N*Bspa2[m]+k];
	  }
	  c2 = c2 + Bspa3[i]*Bspa3[i]*beta_int[i]*beta_int[i]*tmp2;
	  }
	  }
	  }
	 double x_jk[N];
	 for (int i =0; i < N; i++){
	 x_jk[i] = X[N*Bspa1[m]+i]*X[N*Bspa2[m]+i];
	 }
	 if ((c1==0) && (c2==0)){
	  beta_int[m] = s_th_int(beta_hat, lam2+2*lam1, Bspa3[m], x_jk, N);
	 }
     else {
	 beta_int[m] = nr_intx(beta_int[m], beta_hat, lam1, lam2, c1, c2, Bspa3[m], N, x_jk, tol_nr);
	 }
     diff_int[m] = fabs(beta_int_old[m]-beta_int[m]);
    }
	
     /* calculate convergence criteria */
	if(diff_m[0] > diff_m[1]) delta = diff_m[0];
	else delta = diff_m[1];
	
	for (int i=2; i < p_m; i++){
	if (delta < diff_m[i]) delta = diff_m[i];
	}
	for (int i=0; i < p_int; i++){
	if (delta < diff_int[i]) delta = diff_int[i];
	}

}
	
}
