#############################################

####   Create B matrix

#############################################

data.snpinfo<-read.csv("data_SNP_to_Gene_example.csv",as.is=T)     # this file need to have at least two columns, SNP and Gene
                                                                   # the order of SNPs must be the same as the order of SNPs in data file
library(GSA)
KGEE<-GSA.read.gmt("KEGG_example_50genesets.gmt")                  # this is an example file, a portion of the KEGG pathway

N.g<-length(data.snpinfo$Gene)
pat.ind<-matrix(NA,length(KGEE$genesets),N.g)

for (i in 1:N.g) {
tmp.gene<-data.snpinfo$Gene[i]
pat.ind[,i]<-1*sapply(KGEE$genesets,function(x,y) y %in% x,y=tmp.gene)
}
A<- t(pat.ind) %*% pat.ind
diag(A)<-1

a<-(sum(A!=0)-N.g)/2
cnt<-0
B.spa<-matrix(NA,a,3)
for (i in 1:(N.g-1)){
for (j in (i+1):N.g){
  if (A[i,j]!=0) {
     cnt<-cnt+1
     B.spa[cnt,1]<-i
     B.spa[cnt,2]<-j
     B.spa[cnt,3]<-1/A[i,j]
     }
}
}

# if you would like to set a uniform weight for all allowed interactions
B.spa[,3]<-1

#### save B.spa as the input B matrix for fitting the algorithm

write.table(B.spa,"B_matrix_example.csv",sep=",",na="",col.names=T,row.names=F,quote=F)