
dyn.load("cd_update_speed.so")
dyn.load("calkkt.so")

run_algorithm<-function(data,B,tol.cd,tol.nr,lam.int,n.pre,ratio){
N.snp<-ncol(data)-2
data.Y<-data$pheno
data.X<-data[,3:(N.snp+2)]

N<-length(data.Y)
B.old<-B
# standardize data and compute initial score

data.Y<-(data.Y-mean(data.Y))/(sd(data.Y)*sqrt(N.snp-1))          # y is phenotype

M<-apply(data.X,2,mean,na.rm=T)
S<-apply(data.X,2,sd,na.rm=T)
S<-S*sqrt(N-1)
MM<-matrix(M,nrow=nrow(data.X),ncol=ncol(data.X),byrow=T)
SS<-matrix(S,nrow=nrow(data.X),ncol=ncol(data.X),byrow=T)
data.X<-(data.X-MM)/SS

a.score<-as.vector((data.Y-mean(data.Y)) %*% as.matrix(data.X))
a.score<-abs(a.score)

n.subset<-n.pre*5
KKT<-T
#### start doubling when KKT is not satisfied
doub<--1
while (KKT & 2*n.subset <= N.snp){
doub<-doub+1
if(doub > 0) {print(paste("KKT conditions not satisfied, subset doubled ",doub," time(s)"))}

n.subset<-n.subset*2
Y<-data.Y

snp.keep<-sort(order(a.score,decreasing =T)[1:n.subset])
keep<-cbind(snp.keep,new.ind=1:length(snp.keep))
X<-data.X[,snp.keep]

B.spa<-B.old
B.spa$old.intx<-1:nrow(B.spa)
int.keep<-(B.spa$V1 %in% snp.keep) & (B.spa$V2 %in% snp.keep)
B.spa<-B.spa[int.keep,]

B.spa$V4<-1:nrow(B.spa)
B.new<-merge(B.spa,keep,by.x="V2",by.y="snp.keep")
names(B.new)[6]<-"V2.new"
B.new<-merge(B.new,keep,by.x="V1",by.y="snp.keep")
B.new<-B.new[order(B.new$V4),]
B.spa<-B.new[,c("new.ind","V2.new","V3")]


p.m<-ncol(X)
X<-as.matrix(X)

## Calculate Interaction Data:
p.int<-nrow(B.spa)
X.int<-X[,B.spa[,1]]*X[,B.spa[,2]]

#
beta.m<-rep(0,p.m)
beta.int<-rep(0,p.int)                  # beta.int has only those with non-inf valus of B

lam.tmp<-lam.int                 # set initial guess

result.tmp<-.C("cd_update_testspeed",as.double(X),as.double(Y),as.integer(N),as.double(lam.tmp),as.double(lam.tmp*ratio),as.integer(p.m),as.integer(p.int),as.integer(B.spa[,1]-1),as.integer(B.spa[,2]-1),as.double(B.spa[,3]),as.double(beta.m),as.double(beta.int),as.double(tol.cd),as.double(tol.nr))

main.tmp<-result.tmp[[11]]
int.tmp<-result.tmp[[12]]
n.tmp<-length(main.tmp[main.tmp!=0])
lam1.out<-lam.tmp

lam.00<-lam.tmp

lam.u<-NA
lam.l<-NA
if (n.tmp < n.pre) {lam.u<-lam.tmp; lam.tmp<-lam.tmp/2}
if (n.tmp > n.pre) {lam.l<-lam.tmp; lam.tmp<-lam.tmp*2}               

run<-0
while (abs(n.tmp-n.pre) > 1){
run<-run+1
result.tmp<-.C("cd_update_testspeed",as.double(X),as.double(Y),as.integer(N),as.double(lam.tmp),as.double(lam.tmp*ratio),as.integer(p.m),as.integer(p.int),as.integer(B.spa[,1]-1),as.integer(B.spa[,2]-1),as.double(B.spa[,3]),as.double(beta.m),as.double(beta.int),as.double(tol.cd),as.double(tol.nr))

main.tmp<-result.tmp[[11]]
int.tmp<-result.tmp[[12]]
n.tmp<-length(main.tmp[main.tmp!=0])
lam1.out<-lam.tmp

if (n.tmp < n.pre) {
    lam.u<-lam.tmp
}
if (n.tmp > n.pre) {
    lam.l<-lam.tmp
}

if (!is.na(lam.l) & is.na(lam.u)){lam.tmp<-lam.tmp*2}
if (!is.na(lam.u) & is.na(lam.l)){lam.tmp<-lam.tmp/2}
if (!is.na(lam.l) & !is.na(lam.u)){lam.tmp<-(lam.l+lam.u)/2}

print(paste(n.tmp,"main effects selected; lambda_1 for next cycle =",lam.tmp))
}

act.m<-which(main.tmp!=0)
act.int<-which(int.tmp!=0)

# check KKT condition
if (n.subset < N.snp) {
X.f<-X[,act.m]
beta.m.f<-main.tmp[act.m]

X.int.f<-X.int[,act.int]
beta.int.f<-int.tmp[act.int]

X.ff<-cbind(X.f,X.int.f)
beta.ff<-c(beta.m.f,beta.int.f)
Y.f<-as.vector(X.ff %*% beta.ff)

snp.check<-1:N.snp
snp.check<-snp.check[-snp.keep]

resd<-Y-Y.f
dataX<-as.double(as.matrix(data.X))

score.omit<-as.vector(t(resd) %*% as.matrix(data.X[,snp.check]))

KKT.main<-max(abs(score.omit)) > lam1.out

# KKT for interaction     
B.test1<-B.old[((B.old$V1 %in% snp.check) & (B.old$V2 %in% snp.keep)) | ((B.old$V2 %in% snp.check) & (B.old$V1 %in% snp.keep)),]
B.test2<-B.old[((B.old$V1 %in% snp.check) & (B.old$V2 %in% snp.check)),]

if (nrow(B.test2) > 0){
Btest1<-as.integer(B.test2[,1])
Btest2<-as.integer(B.test2[,2])
Btest3<-as.double(B.test2[,3])
score<-rep(-99,nrow(B.test2))

s.tmp<-.C("calkkt",size_score=as.integer(length(score)),score=as.double(score),N=as.integer(N),N_s=as.integer(N.snp),dataX=dataX,Btest1=Btest1,Btest2=Btest2,Btest3=Btest3,resd=as.double(resd))
score.int2<-abs(s.tmp$score)

KKT.int1<-max(score.int2) > 2*lam1.out+ratio*lam1.out
}

if (nrow(B.test2) ==0) {KKT.int1<-F}

main.sel<-snp.keep[act.m]
oneeffect<-(B.test1$V1 %in% main.sel) | (B.test1$V2 %in% main.sel)
B.test3<-B.test1[!oneeffect,]
B.test4<-B.test1[oneeffect,]

if (nrow(B.test3) > 0){
Btest1<-as.integer(B.test3[,1])
Btest2<-as.integer(B.test3[,2])
Btest3<-as.double(B.test3[,3])
score<-rep(-99,nrow(B.test3))

s.tmp<-.C("calkkt",size_score=as.integer(length(score)),score=as.double(score),N=as.integer(N),N_s=as.integer(N.snp),dataX=dataX,Btest1=Btest1,Btest2=Btest2,Btest3=Btest3,resd=as.double(resd))
score.int3<-abs(s.tmp$score)

KKT.int2<-max(score.int3) >  2*lam1.out+ratio*lam1.out
}
if (nrow(B.test3) == 0) {KKT.int2<-F}

if (nrow(B.test4) > 0){
Btest1<-as.integer(B.test4[,1])
Btest2<-as.integer(B.test4[,2])
Btest3<-as.double(B.test4[,3])

score<-rep(-99,nrow(B.test4))

s.tmp<-.C("calkkt",size_score=as.integer(length(score)),score=as.double(score),N=as.integer(N),N_s=as.integer(N.snp),dataX=dataX,Btest1=Btest1,Btest2=Btest2,Btest3=Btest3,resd=as.double(resd))
score.int4<-abs(s.tmp$score)

KKT.int3<-max(score.int4) >  lam1.out+ratio*lam1.out
}
if (nrow(B.test4)==0) { KKT.int3<-F}


KKT<-KKT.main | KKT.int1 | KKT.int2 | KKT.int3
}
if (n.subset >= N.snp) {KKT<-F}
}

int.out<-data.frame(B.new[act.int,])
names(int.out)<-c("SNP1","SNP2","weight","act.int.oldindx","act.int","V2.new","V1.new")
beta.int.shrunk<-int.tmp[act.int]
int.out<-cbind(int.out,beta.int.shrunk)
out<-list(beta.main.shrunk=main.tmp[act.m],int.out=int.out,n.sel=n.tmp,act.m=snp.keep[act.m],doubling=doub)
}

# input data data.X, data.Y and B.spa

n.pre<-25
ratio<-0.5
lam.int<-0.1
tol.cd<-0.00001
tol.nr<-0.00001


data.X<-read.csv("example/data.X_sim1.csv",as.is=T)
data.Y<-read.csv("example/data.Y_M2_sim1.csv",as.is=T)
data.Y<-data.Y$x
B.old<-read.csv("example/B2_first20intx.csv",as.is=T)

data<-cbind(1:length(data.Y),data.Y,data.X)
names(data)[1:2]<-c("id","pheno")

result<-run_algorithm(data,B.old,tol.cd,tol.nr,lam.int,n.pre,ratio)
